<template>
  <div class="mt-8">
    <div class="container mx-auto px-8">
      <form @submit.prevent="onSubmit" class="space-y-6">
        <div class="row">
          <label for="fullName" class="flex flex-col">
            <span class="font-semibold">Full Name</span>
            <input
              id="fullName"
              type="text"
              v-model="fullName"
              placeholder="mMoney..."
              class="px-4 py-3 rounded-lg border border-gray-200 mt-1"
            />
          </label>
        </div>
        <div class="row">
          <label for="email" class="flex flex-col">
            <span class="font-semibold">Email Address</span>
            <input
              id="email"
              type="email"
              v-model="email"
              placeholder="mMoney@gmail.com..."
              class="px-4 py-3 rounded-lg border border-gray-200 mt-1"
            />
          </label>
        </div>
        <div class="row">
          <label for="password" class="flex flex-col">
            <span class="font-semibold">Password</span>
            <input
              v-model="password"
              id="password"
              type="password"
              placeholder="Example"
              class="px-4 py-3 rounded-lg border border-gray-200 mt-1"
            />
          </label>
        </div>
        <div class="row">
          <button
            class="py-3 text-center w-full bg-primary text-white font-bold rounded-lg"
            type="submit"
            v-if="!isPending"
          >
            Sign Up
          </button>
          <button
            class="py-3 text-center w-full bg-gray-800 text-white font-bold rounded-lg"
            type="button"
            disabled
            v-else
          >
            Loading...
          </button>
        </div>
      </form>
      <div class="text-left mt-4 text-red" v-if="error">
        <span>{{ error }}</span>
      </div>
      <div class="w-full text-center mt-6">
        <span class="font-semibold">I'm already a member.</span>
        <span class="text-primary font-semibold ml-1">
          <router-link :to="{ name: 'login', params: {} }">Sign In</router-link>
        </span>
      </div>
    </div>
  </div>
</template>
<script>
import { ref } from "vue";
import { useRouter } from "vue-router";
import { useSignUp } from "@/composables/useSignUp";
export default {
  setup() {
    const fullName = ref("");
    const email = ref("");
    const password = ref("");
    const { error, isPending, signUp } = useSignUp();
    const router = useRouter();
    async function onSubmit() {
      await signUp(email.value, password.value, fullName.value);
      if (!error) router.push({ name: "Profile", params: {} });
    }

    return {
      fullName,
      email,
      password,
      onSubmit,
      error,
      isPending,
    };
  },
};
</script>
